package uk.ac.bbsrc.babraham.ChipMonk.Displays.ConditionTree;

import java.util.Enumeration;
import java.util.Hashtable;

import javax.swing.tree.DefaultMutableTreeNode;
import uk.ac.bbsrc.babraham.ChipMonk.DataTypes.DataStore;
;

public class ConditionTreeNode extends DefaultMutableTreeNode implements Comparable{
	
	private DataStore data;
	private Hashtable distances = new Hashtable();
	
	
	public ConditionTreeNode (DataStore data) {
		super(data);
		this.data = data;
	}
	
	public void add (ConditionTreeNode child, Float distance) {
		super.add(child);
		distances.put(child,distance);
//		if (distance.floatValue() < 0) {
//			System.err.println("Negative distance "+distance+" when adding child "+child+" to node "+this);
//		}
	}
	
	public Float getDistanceForChild (ConditionTreeNode child) {
		if (distances.containsKey(child)) {
			return (Float)distances.get(child);
		}
		else {
			return null;
		}
	}
	
	public float getDistanceFromRoot () {
		return getDistanceFromRoot(0);
	}
	
	private float getDistanceFromRoot (float currentDistance) {
		if (getParent() == null) {
			return currentDistance;
		}
		else {
			currentDistance += ((ConditionTreeNode)getParent()).getDistanceForChild(this).floatValue();
			return ((ConditionTreeNode)getParent()).getDistanceFromRoot(currentDistance);
		}
	}
	
	public int getTotalChildCount () {
		MutableInteger i = new MutableInteger(0);
		getTotalChildCount(i);
		return i.intValue();
	}
	
	private void getTotalChildCount (MutableInteger currentCount) {
		Enumeration e = children();
		while (e.hasMoreElements()) {
			ConditionTreeNode n = (ConditionTreeNode)e.nextElement();
			if (n.isLeaf()) {
				currentCount.increment();
			}
			else {
				n.getTotalChildCount(currentCount);
			}
		}
	}
	
	public String toString () {
		if (data==null) {
			return "";
		}
		else {
			return data.name();
		}
	}

	private class MutableInteger {
		private int i;
		public MutableInteger (int i) {
			this.i=i;
		}
		
		public void increment () {
			i++;
		}
		
		public int intValue () {
			return i;
		}
	}

	public int compareTo(Object c) {
		return getTotalChildCount() - ((ConditionTreeNode)c).getTotalChildCount();	
	}
}
