package uk.ac.bbsrc.babraham.ChipMonk.Displays.DataViewer;

import java.awt.Color;
import java.awt.Component;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;

import uk.ac.bbsrc.babraham.ChipMonk.DataTypes.DataGroup;
import uk.ac.bbsrc.babraham.ChipMonk.DataTypes.DataSet;
import uk.ac.bbsrc.babraham.ChipMonk.DataTypes.ProbeList;

public class DataTreeRenderer extends DefaultTreeCellRenderer {
	
	private static Icon dataSetIcon = new ImageIcon(ClassLoader.getSystemResource("uk/ac/bbsrc/babraham/ChipMonk/Resources/dataset_icon.png"));
	private static Icon dataGroupIcon = new ImageIcon(ClassLoader.getSystemResource("uk/ac/bbsrc/babraham/ChipMonk/Resources/datagroup_icon.png"));
	private static Icon probeListIcon = new ImageIcon(ClassLoader.getSystemResource("uk/ac/bbsrc/babraham/ChipMonk/Resources/probelist_icon.png"));
	
	public Component getTreeCellRendererComponent (JTree tree, Object value, boolean selected, boolean expanded, boolean leaf, int row, boolean hasFocus) {
		
		if (value instanceof DefaultMutableTreeNode && ((DefaultMutableTreeNode)value).getUserObject() instanceof DataSet) {
			JLabel label = new JLabel(value.toString(),dataSetIcon, JLabel.LEFT);
			if (selected) {
				label.setOpaque(true);
				label.setBackground(Color.LIGHT_GRAY);
			}
			return label;
		}
		else if (value instanceof DefaultMutableTreeNode && ((DefaultMutableTreeNode)value).getUserObject() instanceof DataGroup) {
			JLabel label = new JLabel(value.toString(),dataGroupIcon, JLabel.LEFT);
			if (selected) {
				label.setOpaque(true);
				label.setBackground(Color.LIGHT_GRAY);
			}
			return label;
		}
		else if (value instanceof DefaultMutableTreeNode && ((DefaultMutableTreeNode)value).getUserObject() instanceof ProbeList) {
			JLabel label = new JLabel(value.toString(),probeListIcon, JLabel.LEFT);
			if (selected) {
				label.setOpaque(true);
				label.setBackground(Color.LIGHT_GRAY);
			}
			return label;
		}

		else {
			return super.getTreeCellRendererComponent(tree,value,selected,expanded,leaf,row,hasFocus);
		}
	}

}
